/* DAC variables & libraries */
#include <Wire.h>
#include "Adafruit_MCP4725.h"

//definition joystick
#define JOYSTICK_X A8  // avance / recule
#define JOYSTICK_Y A9  // vitesse 

int vit_motD =0 ;
int vit_motG =0;

#define MAX_SPEED 255

// moteur gauche
#define avanceG   48
#define arriereG  46

// mouteur droit
#define avanceD   47
#define arriereD  49

/* Variable globale */
Adafruit_MCP4725 dac_motorD;
Adafruit_MCP4725 dac_motorG;

/* Define Variateur */
#define VAL_MAX_VAR 700
#define VAL_MIN_VAR 105

void setup() {

  Serial.begin(115200);

  pinMode(avanceG , OUTPUT);
  pinMode(arriereG , OUTPUT);
  digitalWrite(avanceG, LOW);
  digitalWrite(arriereG, LOW);

  pinMode(avanceD , OUTPUT);
  pinMode(arriereD , OUTPUT);
  digitalWrite(avanceD, LOW);
  digitalWrite(arriereD, LOW);

  dac_motorD.begin(0x62);
  dac_motorD.setVoltage(VAL_MIN_VAR, true);
  
  dac_motorG.begin(0x63);
  dac_motorG.setVoltage(VAL_MIN_VAR, true);
  delay(5000);
}

void loop() {

  // enregistrement de la position initial du joystick
  int Xaxis = analogRead(JOYSTICK_X);
  int Yaxis = analogRead(JOYSTICK_Y);
  Serial.println(Xaxis);
  Serial.println(Yaxis);

  if (Xaxis > 540)
  {
    // recule 
    digitalWrite(avanceD, LOW);
    digitalWrite(arriereD, HIGH);
    digitalWrite(avanceG, LOW);
    digitalWrite(arriereG, HIGH);
    vit_motD = map(Yaxis, 540, 1023, 0, 255);
    vit_motG = map(Yaxis, 540, 1023, 0, 255);
    Serial.println(vit_motD);
    Serial.println(vit_motG);
    
  }
  else if (Xaxis < 498)
  {
    digitalWrite(avanceD, HIGH);
    digitalWrite(arriereD, LOW);
    digitalWrite(avanceG, HIGH);
    digitalWrite(arriereG, LOW);
    vit_motD = map(Yaxis, 540, 1023, 0, 255); 
    vit_motG = map(Yaxis, 540, 1023, 0, 255); 
    Serial.println(vit_motD);
    Serial.println(vit_motG);
  }
  else if (Xaxis == 504 ) 
  {
    digitalWrite(avanceD, LOW);
    digitalWrite(arriereD, LOW);
    digitalWrite(avanceG, LOW);
    digitalWrite(arriereG, LOW);
    vit_motD = 0;
    vit_motG = 0;
    Serial.println(vit_motD);
    Serial.println(vit_motG);
  }

  if(vit_motD < 0) vit_motD = 0;
  if(vit_motG < 0) vit_motG = 0;
  setVitesseMot(0,vit_motD);
  setVitesseMot(1,vit_motG);
}


void setVitesseMot(int mot, int vitprc) //mot: 1 pour motD, 0 pour motG , vitprc: vitesse en pourcentage 
{
  int vitesse;
  vitesse = (vitprc * ((VAL_MAX_VAR-VAL_MIN_VAR)/100)) + VAL_MIN_VAR;
  if(vitesse > VAL_MAX_VAR) vitesse = VAL_MAX_VAR;
  if(vitesse < VAL_MIN_VAR) vitesse = VAL_MIN_VAR;
  if(mot == 1) dac_motorG.setVoltage(vitesse, true);
  if(mot == 0) dac_motorD.setVoltage(vitesse, true);
}
